package gov.usgs.earthquake.nshmp.www;

import io.micronaut.runtime.Micronaut;
import io.swagger.v3.oas.annotations.OpenAPIDefinition;
import io.swagger.v3.oas.annotations.info.Info;

@OpenAPIDefinition(
    info = @Info(
        title = "NSHMP Non-NSHM Services",
        description = "### Services not related to a National Seismic Hazard Model:\n" +
            "* Ground Motion Models: \n" +
            "\t* Response spectra \n" +
            "\t* Hanging Wall effects \n" +
            "\t* Ground motion Vs. Distance \n" +
            "\t* Ground motion Vs. magnitude\n"))
public class Application {

  public static void main(String[] args) {
    Micronaut.build(args)
        .mainClass(Application.class)
        .start();
  }
}
