package gov.usgs.earthquake.nshmp.www.gmm;

import org.crac.Context;
import org.crac.Resource;

import com.amazonaws.serverless.proxy.internal.testutils.MockLambdaContext;
import com.amazonaws.serverless.proxy.model.AwsProxyRequest;

import io.micronaut.context.annotation.Value;
import io.micronaut.crac.OrderedResource;
import io.micronaut.function.aws.proxy.MicronautLambdaHandler;
import jakarta.inject.Singleton;

/**
 * Prime application for AWS Lambda snapstart.
 */
@Singleton
public class PrimingResource implements OrderedResource {

  @Value("${nshmp.context-path}")
  String contextPath;

  @Override
  public void beforeCheckpoint(Context<? extends Resource> context) throws Exception {
    try (MicronautLambdaHandler handler = new MicronautLambdaHandler()) {
      handler.handleRequest(
          getAwsProxyRequest(contextPath + "/gmm/spectra"),
          new MockLambdaContext());

      handler.handleRequest(
          getAwsProxyRequest(contextPath + "/gmm/spectra?gmm=BA_08"),
          new MockLambdaContext());

      handler.handleRequest(
          getAwsProxyRequest(contextPath + "/gmm/distance"),
          new MockLambdaContext());

      handler.handleRequest(
          getAwsProxyRequest(contextPath + "/gmm/hw-fw"),
          new MockLambdaContext());

      handler.handleRequest(
          getAwsProxyRequest(contextPath + "/gmm/magnitude"),
          new MockLambdaContext());

      handler.handleRequest(
          getAwsProxyRequest(contextPath),
          new MockLambdaContext());
    }
  }

  @Override
  public void afterRestore(Context<? extends Resource> context) throws Exception {}

  private static AwsProxyRequest getAwsProxyRequest(String path) {

    final AwsProxyRequest awsProxyRequest = new AwsProxyRequest();
    awsProxyRequest.setHttpMethod("GET");
    awsProxyRequest.setPath(path);
    return awsProxyRequest;
  }
}
